{ rev notes
  0.1  original control panel for SMTPRCV
  0.11 added checkbox for verify local users
  0.12 added checkbox for extended error
  0.13 added controls for IMS alias list, NT user DB, and plugin1
  0.13 added controls local black and white lists

  todo:

  turn into a real control panel applet
}
unit PNLMAIN;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Tabnotbk, ExtCtrls, Spin, Grids, DBGrids;

type
  TControlForm = class(TForm)
    ButtonPanel: TPanel;
    MainPanel: TPanel;
    TabbedNotebook1: TTabbedNotebook;
    VerifyCheckBox: TCheckBox;
    RelayCheckbox: TCheckBox;
    OKButton: TButton;
    CancelButton: TButton;
    RootLabel: TLabel;
    RootDirEdit: TEdit;
    RootBrowseButton: TButton;
    Label1: TLabel;
    IncomingEdit: TEdit;
    Button1: TButton;
    LocalNetPanel: TPanel;
    LocalCheckbox: TCheckBox;
    LocalNetMemo: TMemo;
    DomainPanel: TPanel;
    DomainMemo: TMemo;
    Label2: TLabel;
    POPPanel: TPanel;
    CheckboxPanel: TPanel;
    PopAuthCheckBox: TCheckBox;
    POPMainPanel: TPanel;
    PopGroup: TGroupBox;
    LogFileLabel: TLabel;
    IPLabel: TLabel;
    MinuteLabel: TLabel;
    POPLogNameEdit: TEdit;
    POPBrowseButton: TButton;
    MinuteSpin: TSpinEdit;
    DNSCheckboxPanel: TPanel;
    DNSCheckBox: TCheckBox;
    DNSMainPanel: TPanel;
    LogCheckbox: TCheckBox;
    Label3: TLabel;
    InlogEdit: TEdit;
    InLogBrowseButton: TButton;
    DNSMain: TPanel;
    ImportButton: TButton;
    DNSGrid: TStringGrid;
    ExtendedErrorCheckbox: TCheckBox;
    LocalUserCheckBox: TCheckBox;
    VerificationGroupBox: TGroupBox;
    IMSAliasCheckbox: TCheckBox;
    LocalBlackListMemo: TMemo;
    WhiteListMemo: TMemo;
    WhiteListLabel: TLabel;
    BlackListLabel: TLabel;
    RejectionNoticeEdit: TEdit;
    BlackListNoticeLabel: TLabel;
    Plugin1Group: TGroupBox;
    Plugin1CheckBox: TCheckBox;
    Plugin1Label: TLabel;
    Plugin1FileEdit: TEdit;
    BrowseButton: TButton;
    NTUserDatabaseGroup: TGroupBox;
    NTUserCheckbox: TCheckBox;
    GroupLabel: TLabel;
    GroupNameEdit: TEdit;
    SpamTrapCheckBox: TCheckBox;
    SpamTrapGroupBox: TGroupBox;
    Label5: TLabel;
    SpamTrapTimeSpin: TSpinEdit;
    Label4: TLabel;
    SpamTrapUserMemo: TMemo;
    Label6: TLabel;
    procedure CancelButtonClick(Sender: TObject);
    procedure OKButtonClick(Sender: TObject);
    procedure ButtonPanelResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ImportButtonClick(Sender: TObject);
    procedure DNSMainResize(Sender: TObject);
    procedure DNSGridMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MemoExit(Sender: TObject);
    procedure RootBrowseButtonClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure POPBrowseButtonClick(Sender: TObject);
    procedure InLogBrowseButtonClick(Sender: TObject);
    procedure DNSGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure BrowseButtonClick(Sender: TObject);
  private
    { Private declarations }
    MaxXPixelSize,
    MaxYPixelSize: word;
    procedure SetMaxLimits;
    procedure ReadSettings;
    procedure ApplySettings;
  public
    { Public declarations }
    procedure RestrictSize(var msg: TMessage); message WM_GETMINMAXINFO;
  end;

var
  ControlForm: TControlForm;

implementation

uses
  OURREGIS,RCVGLBL,FILEDLG,ANTIRLY,Browsdir;

{$R *.DFM}

procedure TControlForm.FormCreate(Sender: TObject);
begin
  SpamTrapUserList := TStringList.Create;
  LocalNetList := TStringList.Create;
  LocalBlackList := TStringList.Create;
  WhiteList := TStringList.Create;
  LocalDomainList := TStringList.Create;
  DNSServers := TStringList.Create;
  DNSHeaderText := TStringList.Create;
  UIActive := true;
  DNSGrid.Cells[0,0] := 'DNS blacklist server';
  DNSGrid.Cells[1,0] := 'Access denied response';
  SetMaxLimits;
  GetSMTPRCVSettings;
  FixAllPaths;
  ApplySettings;
end;

const
  MinHeight = 320;
  MinWidth = 480;

function Min(I,J : integer) : integer;
begin
  Min := I;
  if (J < I) then Min := J;
end;

function Max(I,J : integer) : integer;
begin
  Max := I;
  if (J > I) then Max := J;
end;

procedure TControlForm.RestrictSize(var Msg: TMessage);
var
   p: PMinMaxInfo;
   XPixels,YPixels : word;
   DC : HDC;
const
  MaxWord = $FFFF;
  Warned : boolean = false;
begin
   DC := GetDC(0);
   XPixels := GetDeviceCaps(DC,HorzRes);
   YPixels := GetDeviceCaps(DC,VertRes);
// The lParam contains a pointer on a structure of type TMinMaxInfo
   p := PMinMaxInfo(Msg.lParam);
// This represents the size of the Window when Maximized
   p.ptMaxSize.x := XPixels;
   p.ptMaxSize.y := YPixels;
// This represents the position of the Window when Maximized
   p.ptMaxPosition.x := 1;
   p.ptMaxPosition.y := 1;
// This represents the minimum size of the Window
   p.ptMinTrackSize.x := MinWidth;
   p.ptMinTrackSize.y := MinHeight;
// This represents the maximum size of the Window
   p.ptMaxTrackSize.x := XPixels;
   p.ptMaxTrackSize.y := YPixels;
end;

procedure TControlForm.SetMaxLimits;
var
  DC : HDC;
begin
  DC := GetDC(0);
  MaxXPixelSize := GetDeviceCaps(DC,HorzRes);
  MaxYPixelSize := GetDeviceCaps(DC,VertRes);
end;

procedure TControlForm.CancelButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TControlForm.OKButtonClick(Sender: TObject);
begin
  ReadSettings;
  SetSMTPRCVSettings;
  Close;
end;

procedure TControlForm.ButtonPanelResize(Sender: TObject);
begin
  if UIActive then begin
    OKButton.Left := (ButtonPanel.Width div 2) - OKButton.Width - 15;
    CancelButton.Left := (ButtonPanel.Width div 2) + 15;
  end;
end;

procedure TControlForm.ReadSettings;
var
  Loop : integer;
  S,S2 : string;
begin
  VerifyDomains := VerifyCheckBox.Checked;
  AllowRelay := RelayCheckbox.Checked;
  MailRootDir := RootDirEdit.Text;
  MailQueueDir := IncomingEdit.Text;
  LocalNets := LocalCheckbox.Checked;
  LocalUsers := LocalUserCheckbox.Checked;
  IMSUserList := IMSAliasCheckbox.Checked;
  NTUserDatabase := NTUserCheckbox.Checked;
  Plugin1UserList := Plugin1Checkbox.Checked;
  Plugin1ConfigFile := Plugin1FileEdit.Text;
  BlackListRejection := RejectionNoticeEdit.Text;
  NTGroupName := GroupNameEdit.Text;
  ExtendedErrors := ExtendedErrorCheckbox.Checked;
  MailInLogEnabled := LogCheckbox.Checked;
  InLogDir := InlogEdit.Text;
  PopAuth := PopAuthCheckBox.Checked;
  SpamTrapping := SpamTrapCheckBox.Checked;
  SpamTrapTimeout := SpamTrapTimeSpin.Value;
  DelayMinutes := MinuteSpin.Value;
  POP3LogDir := POPLogNameEdit.Text;
  DNSLists := DNSCheckBox.Checked;
  LocalNetList.Clear;
  LocalBlackList.Clear;
  WhiteList.Clear;
  LocalDomainList.Clear;
  SpamTrapUserList.Clear;
  DNSServers.Clear;
  DNSHeaderText.Clear;
  for Loop := 0 to LocalNetMemo.Lines.Count-1 do begin
    S := Trim(LocalNetMemo.Lines[Loop]);
    if (S <> '') then
      LocalNetList.Add(S);
  end;
  for Loop := 0 to LocalBlackListMemo.Lines.Count-1 do begin
    S := Trim(LocalBlackListMemo.Lines[Loop]);
    if (S <> '') then
      LocalBlackList.Add(S);
  end;
  for Loop := 0 to WhiteListMemo.Lines.Count-1 do begin
    S := Trim(WhiteListMemo.Lines[Loop]);
    if (S <> '') then
      WhiteList.Add(S);
  end;
  for Loop := 0 to DomainMemo.Lines.Count-1 do begin
    S := Trim(DomainMemo.Lines[Loop]);
    if (S <> '') then
      LocalDomainList.Add(S);
  end;
  for Loop := 0 to SpamTrapUserMemo.Lines.Count-1 do begin
    S := Trim(SpamTrapUserMemo.Lines[Loop]);
    if (S <> '') then
      SpamTrapUserList.Add(S);
  end;
  if UIActive then begin
    for Loop := 1 to DNSGrid.RowCount-1 do begin
      S := DNSGrid.Cells[0,Loop];
      if (S <> '') then begin
        DNSServers.Add(Trim(S));
        S2 := DNSGrid.Cells[1,Loop];
        if (S2 <> '') then
          DNSheaderText.Add(Trim(S2))
        else
          DNSheaderText.Add(Trim(S));
      end;
    end;
  end;
  FixAllPaths;
  ApplySettings;
end;

procedure TControlForm.ApplySettings;
var
  Loop : integer;
begin
  VerifyCheckBox.Checked := VerifyDomains;
  RelayCheckbox.Checked := AllowRelay;
  RootDirEdit.Text := MailRootDir;
  IncomingEdit.Text := MailQueueDir;
  LocalCheckbox.Checked := LocalNets;
  LocalUserCheckbox.Checked := LocalUsers;
  IMSAliasCheckbox.Checked := IMSUserList;
  NTUserCheckbox.Checked := NTUserDatabase;
  Plugin1Checkbox.Checked := Plugin1UserList;
  Plugin1FileEdit.Text := Plugin1ConfigFile;
  RejectionNoticeEdit.Text := BlackListRejection;
  GroupNameEdit.Text := NTGroupName;
  ExtendedErrorCheckbox.Checked := ExtendedErrors;
  LogCheckbox.Checked := MailInLogEnabled;
  InlogEdit.Text := InLogDir;
  PopAuthCheckBox.Checked := PopAuth;
  SpamTrapCheckBox.Checked := SpamTrapping;
  MinuteSpin.Value := DelayMinutes;
  SpamTrapTimeSpin.Value := SpamTrapTimeout;
  POPLogNameEdit.Text := POP3LogDir;
  DNSCheckBox.Checked := DNSLists;
  LocalNetMemo.Lines.clear;
  LocalBlackListMemo.Lines.clear;
  WhiteListMemo.Lines.clear;
  DomainMemo.Lines.clear;
  SpamTrapUserMemo.Lines.clear;
  if UIActive then begin
    for Loop := 1 to DNSGrid.RowCount-1 do begin
      DNSGrid.Cells[0,Loop] := '';
      DNSGrid.Cells[1,Loop] := '';
    end;
    for Loop := 0 to LocalNetList.Count-1 do
      LocalNetMemo.Lines.Add(LocalNetList[Loop]);
    for Loop := 0 to LocalBlackList.Count-1 do
      LocalBlackListMemo.Lines.Add(LocalBlackList[Loop]);
    for Loop := 0 to WhiteList.Count-1 do
      WhiteListMemo.Lines.Add(WhiteList[Loop]);
    for Loop := 0 to LocalDomainList.Count-1 do
      DomainMemo.Lines.Add(LocalDomainList[Loop]);
    for Loop := 0 to SpamTrapUserList.Count-1 do
      SpamTrapUserMemo.Lines.Add(SpamTrapUserList[Loop]);
    for Loop := 0 to DNSServers.Count-1 do
      DNSGrid.Cells[0,Loop+1] := DNSServers[Loop];
    for Loop := 0 to DNSheaderText.Count-1 do
      DNSGrid.Cells[1,Loop+1] := DNSheaderText[Loop];
  end;
end;

procedure TControlForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  UIActive := false;
  LocalNetList.Free;
  LocalBlackList.Free;
  WhiteList.Free;
  LocalDomainList.Free;
  SpamTrapUserList.Free;
  DNSServers.Free;
  DNSHeaderText.Free;
end;

procedure TControlForm.ImportButtonClick(Sender: TObject);
var
  SelectFileName : string;
begin
  LocalNetList.Clear;
  LocalDomainList.Clear;
  DNSServers.Clear;
  DNSHeaderText.Clear;
  GetSettings;
  FixAllPaths;
  SelectFileName := '*.ini';
  if PromptSelectFile('Select AntiRelay INI file name',SelectFileName) then begin
    ReadAntiRelayIni(SelectFileName);
  end;
  FixAllPaths;
  ApplySettings;
end;

procedure TControlForm.DNSMainResize(Sender: TObject);
begin
  if UIActive then
    DNSGrid.ColWidths[1] := DNSGrid.Width - DNSGrid.ColWidths[0] - 5;
end;

procedure TControlForm.DNSGridMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if UIActive then
    DNSGrid.ColWidths[1] := DNSGrid.Width - DNSGrid.ColWidths[0] - 5;
end;

procedure TControlForm.MemoExit(Sender: TObject);
begin
  ReadSettings;
end;

procedure TControlForm.RootBrowseButtonClick(Sender: TObject);
var
  S : string;
begin
  S := RootDirEdit.Text;
  if BrowseDirectory('Mail root directory',S) then begin
    RootDirEdit.Text := FixDirBackSlash(S);
  end;
end;

procedure TControlForm.Button1Click(Sender: TObject);
var
  S : string;
begin
  S := IncomingEdit.Text;
  if BrowseDirectory('Incoming mail directory',S) then begin
    IncomingEdit.Text := FixDirBackSlash(S);
  end;
end;

procedure TControlForm.POPBrowseButtonClick(Sender: TObject);
var
  S : string;
begin
  S := PopLogNameEdit.Text;
  if BrowseDirectory('POP3 log directory',S) then begin
    PopLogNameEdit.Text := FixDirBackSlash(S);
  end;
end;

procedure TControlForm.InLogBrowseButtonClick(Sender: TObject);
var
  S : string;
begin
  S := InlogEdit.Text;
  if BrowseDirectory('POP3 log directory',S) then begin
    InlogEdit.Text := FixDirBackSlash(S);
  end;
end;

procedure TControlForm.DNSGridSelectCell(Sender: TObject; Col,
  Row: Longint; var CanSelect: Boolean);
begin
  if UIActive then
    MemoExit(Sender);
end;

procedure TControlForm.BrowseButtonClick(Sender: TObject);
var
  FileName : string;
begin
  FileName := Plugin1FileEdit.Text;
  if PromptSelectFile('Select Plugin1 config file',FileName) then
    Plugin1FileEdit.Text := FileName;
end;

end.
